#include "NatNetClient.h"

#include <iostream>

int NatNetClient::Initialize(char* szLocalAddress, char* szServerAddress) {
  return ErrorCode_OK;
}

int NatNetClient::Initialize(char* szLocalAddress, char* szServerAddress,
    int HostCommandPort) {
  return ErrorCode_OK;
}

int NatNetClient::Initialize(char* szLocalAddress, char* szServerAddress,
    int HostCommandPort, int HostDataPort) {
  return ErrorCode_OK;
}

int NatNetClient::Uninitialize() {
  return ErrorCode_OK;
}

int NatNetClient::GetServerDescription(sServerDescription* serverDescription) {
  *serverDescription = {
    true,
    "my-computer-name",
    { 127, 0, 0, 1 },
    "my-app",
    { 1, 0, 0, 1 },
    { 2, 2, 2, 2 }
  };

  return ErrorCode_OK;
}

int NatNetClient::GetDataDescriptions(sDataDescriptions** dataDescriptions) {
  // char* names[2] = {
  //   (char*)std::string("foo").c_str(),
  //   (char*)std::string("bar").c_str()
  // };

  // sMarkerSetDescription markerSetDescription = {
  //   "my-marker-set",
  //   2,
  //   names
  // };

  // sDataDescription dummyMarkerSetData = {
  //   Descriptor_MarkerSet,
  //   { &markerSetDescription }
  // };

  sDataDescriptions _dataDescriptions;
  _dataDescriptions = {
    0,
    {}
  };
  *dataDescriptions = &_dataDescriptions;

  return ErrorCode_OK;
}

int NatNetClient::SetDataCallback(
    void (*CallbackFunction)(sFrameOfMocapData*, void*), void* pUserData) {
  MarkerData md[1] = { { 1.0f, 2.0f, 3.0f } };
  sMarkerSetData markerSetData = {
    "my-marker-set",
    1,
    md
  };

  int markerIDs[1] = { 345 };
  float markerSizes[1] = { 4.5 };

  sRigidBodyData rigidBodyData;
  rigidBodyData.ID = 1234;
  rigidBodyData.x = 1.5f;
  rigidBodyData.y = 2.5f;
  rigidBodyData.z = 3.5f;
  rigidBodyData.qx = 0.1f;
  rigidBodyData.qy = 0.2f;
  rigidBodyData.qz = 0.3f;
  rigidBodyData.qw = 0.4f;
  rigidBodyData.nMarkers = 1;
  rigidBodyData.Markers = md;
  rigidBodyData.MarkerIDs = markerIDs;
  rigidBodyData.MarkerSizes = markerSizes;
  rigidBodyData.MeanError = 0.123f;
  rigidBodyData.params = -2;

  sRigidBodyData rbd[1] = { rigidBodyData };
  sSkeletonData skeletonData = {
    777,
    1, rbd
  };

  sFrameOfMocapData* data = new sFrameOfMocapData;
  *data = {
    3,
    1, { markerSetData },
    1, md,
    1, { rigidBodyData },
    1, { skeletonData },
    2,
    {
      { 123, 1.0f, 2.0f, 3.0f, 23.5f, -2 },
      { 456, 13.0f, 24.0f, 35.0f, 123.5f, -1 }
    },
    0, {},
    24.0f,
    123,
    234,
    20.0,
    -34
  };

  CallbackFunction(data, pUserData);

  return ErrorCode_OK;
}
