#ifndef NATNET_CLIENT_MOCK_H
#define NATNET_CLIENT_MOCK_H

#include "NatNetTypes.h"
// #include "NatNetClient.h"

class NatNetClient {
 public:
   NatNetClient(int iType) {}
   ~NatNetClient() {}

   int Initialize(char* szLocalAddress, char* szServerAddress);
   int Initialize(char* szLocalAddress, char* szServerAddress,
     int HostCommandPort);
   int Initialize(char* szLocalAddress, char* szServerAddress,
     int HostCommandPort, int HostDataPort);

   int Uninitialize();

   int GetServerDescription(sServerDescription *pServerDescription);

   int GetDataDescriptions(sDataDescriptions** pDataDescriptions);

   int SetDataCallback(void (*CallbackFunction)(sFrameOfMocapData* pFrameOfData,
     void* pUserData), void* pUserData=0);
};

#endif
